// Shader: /Shaders/LightingModels/Ambient.vsh
//

#version 110

#ifndef MAX_LIGHTS
#error Constant MAX_LIGHTS should be defined.
#endif

struct LightSource
{
    vec3 Position;
};

uniform LightSource u_LightSource[MAX_LIGHTS];

attribute vec4 in_Vertex;
attribute vec3 in_Normal;

varying vec3 out_N;
varying vec4 out_LnDistance[MAX_LIGHTS]; // Combine direction to light and it's distance in one varying.

void main()
{
    out_N = in_Normal; 

    for (int i = 0; i < MAX_LIGHTS; ++i) 
    {
        out_LnDistance[i].xyz = u_LightSource[i].Position - vec3( in_Vertex );
        out_LnDistance[i].w = length( out_LnDistance[i].xyz );
    }

    gl_Position = gl_ModelViewProjectionMatrix * in_Vertex;
}