// Shader: /Shaders/LightingModels/Lambert.vsh
//

#version 110

struct LightSource
{
    vec3 Position;
    float Radius;
};

uniform LightSource u_LightSource;

attribute vec4 in_Vertex;
attribute vec3 in_Normal;

varying vec3 out_N;
varying vec3 out_L;

varying float out_Distance;

void main()
{
    out_N = in_Normal; 
    out_L = u_LightSource.Position - vec3( in_Vertex );
    
    out_Distance = length( out_L );

    gl_Position = gl_ModelViewProjectionMatrix * in_Vertex;
}