// Shader: /Shaders/LightingModels/Phong.vsh
//

#version 110

struct LightSource
{
    vec3 Position;
};

uniform LightSource u_LightSource;
uniform vec3 u_ViewPosition;

attribute vec4 in_Vertex;
attribute vec3 in_Normal;

varying vec3 out_N;
varying vec3 out_L;
varying vec3 out_V;

varying float out_Distance;

void main()
{
    out_N = in_Normal; 
    out_L = u_LightSource.Position - vec3( in_Vertex );
    out_V = u_ViewPosition - vec3( in_Vertex );

    out_Distance = length( out_L );

    gl_Position = gl_ModelViewProjectionMatrix * in_Vertex;
}