// Shader: /Shaders/Shadow/ShadowVolume/ShadowCap.vsh
//

#version 110

#ifndef NEAR
#ifndef FAR
#error Macro NEAR or FAR should be defined.
#endif
#endif

#ifdef FAR

struct LightSource
{
    vec3 Position;
};

uniform LightSource u_LightSource;

#endif

attribute vec4 in_Vertex;

void main()
{
//#ifdef ALPHA
    gl_FrontColor = gl_Color;
    gl_BackColor = gl_Color;
//#endif

#ifdef NEAR
    gl_Position = gl_ModelViewProjectionMatrix * in_Vertex;
#else // FAR
    gl_Position = gl_ModelViewProjectionMatrix * vec4( in_Vertex.xyz - u_LightSource.Position, 0.0 );
#endif
}